#include <fstream>
#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <queue>
#include <cmath>
#include <algorithm>
using namespace std;

using ll = long long;

//                                              ВАНЯ ПАНИН 542 ЛЕГЕНДА!!!!!

const int maxn = 400;
const int inf = 1e9 + 239;


void solve() {
    int n, m;
    ll t;
    cin >> n >> m >> t;
    vector<ll> a(n);
    vector<ll> pref(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }
    vector<ll> st(m);
    for (int i = 0; i < m; i++) {
        cin >> st[i];
        st[i]--;
    }
    ll ans = 0;
    for (ll i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int r = max(i, st[j]) + 1;
            int l = min(i, st[j]);
            ll dist = pref[r] - pref[l];
            ll cur = abs(st[j] - i) + 1;
            cur += (t - dist) / a[i];
            if (dist <= t) {
                ans = max(ans, cur);
            }
        }
    }
    cout << ans << '\n';

}


//                                              ВАНЯ ПАНИН 542 ЛЕГЕНДА!!!!!


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}

//                                              ВАНЯ ПАНИН 542 ЛЕГЕНДА!!!!!

